local UIConfig = CreateFrame("Frame", "MOTSSSframe", UIParent, "UIPanelDialogTemplate");
UIConfig:SetMovable(true);
UIConfig:EnableMouse(true);
UIConfig:RegisterForDrag("LeftButton");
UIConfig:SetScript("OnDragStart", UIConfig.StartMoving);
UIConfig:SetScript("OnDragStop", UIConfig.StopMovingOrSizing);
UIConfig:SetSize(352,201);
UIConfig:SetPoint("TOP", UIParent, "TOP",300,0);
UIConfig:SetShown(false);
UIConfig:RegisterEvent("PLAYER_ENTERING_WORLD");
UIConfig:SetScript('OnEvent', function(self, event, ...)
    if (event == "PLAYER_ENTERING_WORLD" ) then
        
        local isInstance, instanceType = IsInInstance();
        if (isInstance == true and ((instanceType == "party") or (instanceType == "raid"))) then
            local instanceName, instanceType, difficultyID, difficultyName, maxPlayers, dynamicDifficulty,
                    isDynamic, instanceID, instanceGroupSize, LfgDungeonID = GetInstanceInfo();
            if (instanceName == "Mists of Tirna Scithe") then
                UIConfig:SetShown(true);
            end
        end
    end
end
);

local count = 0;

--[[

RING
0 - yes
1 - no

FORM
0 - flower
1 - leaf

FILL
0 - empty
1 - full


]]--
local table = 
{
    {
        id = 1,

        ring = 0;
        form = 0;
        fill = 0;

        selected = false
    },
    {
        id = 2;

        ring = 0;
        form = 0;
        fill = 1;

        selected = false
    },
    {
        id = 3,

        ring = 0;
        form = 1;
        fill = 0;

        selected = false
    },
    {
        id = 4,
        
        ring = 0;
        form = 1;
        fill = 1;

        selected = false
    },
    {
        id = 5,

        ring = 1;
        form = 0;
        fill = 0;

        selected = false
    },
    {
        id = 6,

        ring = 1;
        form = 0;
        fill = 1;

        selected = false
    },
    {
        id = 7,

        ring = 1;
        form = 1;
        fill = 0;

        selected = false
    },
    {
        id = 8,

        ring = 1;
        form = 1;
        fill = 1;

        selected = false
    }
}


function addButtons()
    local ypos = -25;
    local xpos = 7;
    local winner = 0
    local blackTable = {0, 0, 0, 0};
    local redTable = {1, 0, 0, 1};
    local greenTable = {0, 1, 0, 1};

    for i = 1, 8 do

        if i == 5  then
            ypos = -108;
            xpos = 7;
        end
        
        local backdrop = CreateFrame("Frame", "backdrop" .. i, UIConfig, BackdropTemplateMixin and "BackdropTemplate")
        backdrop:SetPoint("TOPLEFT",UIConfig,"TOPLEFT",xpos,ypos);
        backdrop:SetWidth(85);
        backdrop:SetHeight(85);
        backdrop:SetBackdrop({
            --bgFile = "Interface/Tooltips/UI-Tooltip-Background",
            edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
            edgeSize = 30,
            --insets = { left = 4, right = 4, top = 4, bottom = 4 },
        })
        backdrop:SetBackdropBorderColor(0, 0, 0, 0);
        local button = CreateFrame("Button", "button" .. i, backdrop, "SecureActionButtonTemplate");
        button:SetWidth(75);
        button:SetHeight(75);
        button:SetPoint("CENTER",backdrop,"CENTER");
        button:SetNormalTexture("Interface/AddOns/MistsOfTirnaScitheHelper/Images/" .. i);
        button:SetPushedTexture("Interface/AddOns/MistsOfTirnaScitheHelper/Images/" .. i);
        --button:SetHighlightTexture("Interface/AddOns/MistsOfTirnaScitheSmartSolve/Images/" .. i);
        button:SetScript("OnClick", function(self)
            local f = self:GetParent()
            table[i].selected = not table[i].selected;
            local red, green, blue, alpha = f:GetBackdropBorderColor()
            red = tonumber(string.format("%.3f", red))
            green = tonumber(string.format("%.3f", green))
            blue = tonumber(string.format("%.3f", blue))
            alpha = tonumber(string.format("%.3f", alpha))
            local bdbc = {red, green , blue, alpha}
            if listCompare(bdbc, blackTable) then
                f:SetBackdropBorderColor(1, 0, 0, 1);
                count = count + 1;
                if winner ~= 0 then
                    _G["backdrop".. winner]:SetBackdropBorderColor(1, 0, 0, 1);
                end
            elseif listCompare(bdbc, redTable) then
                f:SetBackdropBorderColor(0, 0, 0, 0);
                count = count - 1;
                if winner ~= 0 then
                    _G["backdrop".. winner]:SetBackdropBorderColor(1, 0, 0, 1);
                end
            elseif listCompare(bdbc, greenTable) then
                f:SetBackdropBorderColor(0, 0, 0, 0);
                count = count - 1;
            end

            winner = checkKey(count)
            if winner ~= 0 then
                _G["backdrop".. winner]:SetBackdropBorderColor(0, 1, 0, 1);
            end
        end
        );
        xpos = xpos + 85;
    end
end


function listCompare(list1, list2)
    for k = 1, 4 do
        if list1[k] ~= list2[k] then
            return false
        end
    end
    return true
end




addButtons();

function copy1(obj)
    if type(obj) ~= 'table' then return obj end
    local res = {}
    for k, v in pairs(obj) do res[copy1(k)] = copy1(v) end
    return res
end

function checkKey(counter)
    local returnID;
    local found = 0;
    if counter == 4 then
        local list = {};
        local j = 1;
        for i = 1, 8 do
            if table[i].selected == true then
                list[j] = copy1(table[i]);
                j = j+1;
            end
        end
        local sumRing = list[1].ring + list[2].ring + list[3].ring + list[4].ring;
        local sumForm = list[1].form + list[2].form + list[3].form + list[4].form;
        local sumFill = list[1].fill + list[2].fill + list[3].fill + list[4].fill;
        if sumRing == 1 then
            if list[1].ring == 1 then returnID = list[1].id; found = found + 1;
            elseif list[2].ring == 1 then returnID = list[2].id; found = found + 1;
            elseif list[3].ring == 1 then returnID = list[3].id; found = found + 1;
            elseif list[4].ring == 1 then returnID = list[4].id; found = found + 1;
            end
        end
        if sumForm == 1 then
            if list[1].form == 1 then returnID = list[1].id; found = found + 1;
            elseif list[2].form == 1 then returnID = list[2].id; found = found + 1;
            elseif list[3].form == 1 then returnID = list[3].id; found = found + 1;
            elseif list[4].form == 1 then returnID = list[4].id; found = found + 1;
            end
        end
        if sumFill == 1 then
            if list[1].fill == 1 then returnID = list[1].id; found = found + 1;
            elseif list[2].fill == 1 then returnID = list[2].id; found = found + 1;
            elseif list[3].fill == 1 then returnID = list[3].id; found = found + 1;
            elseif list[4].fill == 1 then returnID = list[4].id; found = found + 1;
            end
        end
        if sumRing == 3 then
            if list[1].ring == 0 then returnID = list[1].id; found = found + 1;
            elseif list[2].ring == 0 then returnID = list[2].id; found = found + 1;
            elseif list[3].ring == 0 then returnID = list[3].id; found = found + 1;
            elseif list[4].ring == 0 then returnID = list[4].id; found = found + 1;
            end
        end
        if sumForm == 3 then
            if list[1].form == 0 then returnID = list[1].id; found = found + 1;
            elseif list[2].form == 0 then returnID = list[2].id; found = found + 1;
            elseif list[3].form == 0 then returnID = list[3].id; found = found + 1;
            elseif list[4].form == 0 then returnID = list[4].id; found = found + 1;
            end
        end
        if sumFill == 3 then
            if list[1].fill == 0 then returnID = list[1].id; found = found + 1;
            elseif list[2].fill == 0 then returnID = list[2].id; found = found + 1;
            elseif list[3].fill == 0 then returnID = list[3].id; found = found + 1;
            elseif list[4].fill == 0 then returnID = list[4].id; found = found + 1;
            end
        end
    end
    if found ~= 1 then
        if found > 1 then
            print("|cff0000ffMOTSSS|r |cffFF4500found " .. found .. " different solutions to the chosen symbols. Please check your symbols and try again!|r")
        end
        return 0
    else
        return returnID
    end
end

--UIConfig:hide();

_G["SLASH_motsh1"] = "/motsh";
SlashCmdList["motsh"] = function(cmd)
	UIConfig:SetShown(not UIConfig:IsVisible());
end
